/*
 * Preferences - this class reads a section of a given filename
 *               for default values in input boxes.
 */
import java.awt.*;
import java.io.*;
import java.util.*;

public class Preferences
{

    public Preferences(MyTextArea traceArea) {
        trace = traceArea;
    }

    public Hashtable getData(String filename, String heading) {
        FileInputStream     file_in = null;
        DataInputStream     data_in = null;
        String              line;
        String              param;
	    String              value;
	    Hashtable           properties = null;
        int                 index;
        String              trimLine;
        StringTokenizer     tokens;
        String              token;
        
        File file = new File(filename);
        if ( file != null ) {
            try {
                file_in = new FileInputStream( file );
            }
            catch (FileNotFoundException e) {
                trace.appendText("Dialer.readPreferences: caught FileNotFoundException\n");
            }
            if (file_in != null) {
                data_in = new DataInputStream(file_in);
            }

            if ( heading != null ) {
                try {
        	        readFile:
        	        while ((line = data_in.readLine()) != null) {
        	            trimLine = line.trim();
        	            
        	            if ( trimLine.equals( heading ) ) {
        	                
        	                properties = new Hashtable( 5, 5 );
        	                while ( (line = data_in.readLine()) != null) {
                	            trimLine = line.trim();
                	            
                	            if ( trimLine.equals ( "[End]" ) ) {
                	                break readFile;
                	            }
                	            
                	            if ( trimLine != null ) {
                	                tokens = new StringTokenizer( trimLine, "=" );
                    	            
                    	            if ( tokens.countTokens() > 0 ) {
                    	                if ( tokens.hasMoreTokens() ) {
                        	                token = tokens.nextToken();
                        	                param = token.trim();
                        	            } else {
                        	                break;
                        	            }
                    	            
                        	            value = "";
                        	            if ( tokens.hasMoreTokens() ) {
                        	                token = tokens.nextToken();
                        	                value = token.trim();
                        	            }
                    	            
                        	            properties.put( param, value );
                        	        }
                        	    }
                	        }
        	                break;
        	            }
        	        }
        	    }
        	    catch (IOException e) {
                    trace.appendText("Preferences.readData: caught IOException\n");
                }
            } else {
                try {
        	        while ((line = data_in.readLine()) != null) {
        	            trimLine = line.trim();
        	            
        	            if ( (index = trimLine.indexOf('=')) != -1 ) {
                            param = trimLine.substring( 0, index );
            	            value = trimLine.substring( index + 1 );
            	            properties.put( param, value );
            	        }
        	        }
        	    }
        	    catch (IOException e) {
                    trace.appendText("Preferences.readData: caught IOException\n");
                }
            }
        }
        return properties;
    }
    
    public void trimObjects(Hashtable table, String throwChars) {
	    String              data;
        StringBuffer        buffer;
        StringTokenizer     tokens;
        Enumeration         keys;
        Object              key;
        
        keys = table.keys();
        
        while ( keys.hasMoreElements() ) {
            key = keys.nextElement();
            data = (String) table.get ( key );
            
            buffer = new StringBuffer();
            tokens = new StringTokenizer ( data, throwChars );
            
            while ( tokens.hasMoreTokens() ) {
                buffer.append ( tokens.nextToken() );
            }
            data = buffer.toString();
            
            table.put ( key, data );
        }
    }
    MyTextArea          trace;
}

/*while ((line = data_in.readLine()) != null) {
        	            trimLine = line.trim();
        	            
        	            if ( trimLine.equals( heading ) ) {
        	                
        	                while ((line = data_in.readLine()) != null) {
                	            trimLine = line.trim();
                	            
                	            if ( (index = trimLine.indexOf('=')) != -1 ) {
                                    param = trimLine.substring( 0, index );
                    	            value = trimLine.substring( index + 1 );
                    	            properties.put( param, value );
                    	        }
                	        }
        	                break;
        	            }
        	        }*/